CREATE SEQUENCE ext_log_entries_id_seq INCREMENT BY 1 MINVALUE 1 START 1;
CREATE TABLE brand (id UUID NOT NULL, name VARCHAR(255) DEFAULT NULL, PRIMARY KEY(id));
COMMENT ON COLUMN brand.id IS '(DC2Type:uuid)';
CREATE TABLE app_user (id UUID NOT NULL, username VARCHAR(180) NOT NULL, email VARCHAR(180) NOT NULL, password VARCHAR(100) NOT NULL, password_request_token VARCHAR(255) DEFAULT NULL, roles TEXT NOT NULL, firstname VARCHAR(255) DEFAULT NULL, lastname VARCHAR(255) DEFAULT NULL, preferences JSON DEFAULT NULL, created TIMESTAMP(0) WITHOUT TIME ZONE NOT NULL, updated TIMESTAMP(0) WITHOUT TIME ZONE NOT NULL, last_login TIMESTAMP(0) WITHOUT TIME ZONE DEFAULT NULL, PRIMARY KEY(id));
CREATE UNIQUE INDEX UNIQ_88BDF3E9F85E0677 ON app_user (username);
CREATE UNIQUE INDEX UNIQ_88BDF3E9E7927C74 ON app_user (email);
COMMENT ON COLUMN app_user.id IS '(DC2Type:uuid)';
COMMENT ON COLUMN app_user.roles IS '(DC2Type:array)';
CREATE TABLE pantry (id UUID NOT NULL, name VARCHAR(255) DEFAULT NULL, enabled BOOLEAN DEFAULT NULL, PRIMARY KEY(id));
COMMENT ON COLUMN pantry.id IS '(DC2Type:uuid)';
CREATE TABLE users_pantries (pantry_id UUID NOT NULL, user_id UUID NOT NULL, PRIMARY KEY(pantry_id, user_id));
CREATE INDEX IDX_F6E82D8B4DF44FAA ON users_pantries (pantry_id);
CREATE INDEX IDX_F6E82D8BA76ED395 ON users_pantries (user_id);
COMMENT ON COLUMN users_pantries.pantry_id IS '(DC2Type:uuid)';
COMMENT ON COLUMN users_pantries.user_id IS '(DC2Type:uuid)';
CREATE TABLE product (id UUID NOT NULL, brand_id UUID DEFAULT NULL, name VARCHAR(255) NOT NULL, barcode VARCHAR(255) DEFAULT NULL, openfoodfacts_url VARCHAR(255) DEFAULT NULL, PRIMARY KEY(id));
CREATE INDEX IDX_D34A04AD44F5D008 ON product (brand_id);
COMMENT ON COLUMN product.id IS '(DC2Type:uuid)';
COMMENT ON COLUMN product.brand_id IS '(DC2Type:uuid)';
CREATE TABLE product_presence (id UUID NOT NULL, product_id UUID DEFAULT NULL, pantry_id UUID DEFAULT NULL, quantity INT NOT NULL, expiration DATE DEFAULT NULL, PRIMARY KEY(id));
CREATE INDEX IDX_A2C7AD324584665A ON product_presence (product_id);
CREATE INDEX IDX_A2C7AD324DF44FAA ON product_presence (pantry_id);
COMMENT ON COLUMN product_presence.id IS '(DC2Type:uuid)';
COMMENT ON COLUMN product_presence.product_id IS '(DC2Type:uuid)';
COMMENT ON COLUMN product_presence.pantry_id IS '(DC2Type:uuid)';
CREATE TABLE ext_log_entries (id INT NOT NULL, action VARCHAR(8) NOT NULL, logged_at TIMESTAMP(0) WITHOUT TIME ZONE NOT NULL, object_id VARCHAR(64) DEFAULT NULL, object_class VARCHAR(191) NOT NULL, version INT NOT NULL, data TEXT DEFAULT NULL, username VARCHAR(191) DEFAULT NULL, PRIMARY KEY(id));
CREATE INDEX log_class_lookup_idx ON ext_log_entries (object_class);
CREATE INDEX log_date_lookup_idx ON ext_log_entries (logged_at);
CREATE INDEX log_user_lookup_idx ON ext_log_entries (username);
CREATE INDEX log_version_lookup_idx ON ext_log_entries (object_id, object_class, version);
COMMENT ON COLUMN ext_log_entries.data IS '(DC2Type:array)';
ALTER TABLE users_pantries ADD CONSTRAINT FK_F6E82D8B4DF44FAA FOREIGN KEY (pantry_id) REFERENCES pantry (id) ON DELETE CASCADE NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE users_pantries ADD CONSTRAINT FK_F6E82D8BA76ED395 FOREIGN KEY (user_id) REFERENCES app_user (id) ON DELETE CASCADE NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE product ADD CONSTRAINT FK_D34A04AD44F5D008 FOREIGN KEY (brand_id) REFERENCES brand (id) NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE product_presence ADD CONSTRAINT FK_A2C7AD324584665A FOREIGN KEY (product_id) REFERENCES product (id) NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE product_presence ADD CONSTRAINT FK_A2C7AD324DF44FAA FOREIGN KEY (pantry_id) REFERENCES pantry (id) NOT DEFERRABLE INITIALLY IMMEDIATE;


INSERT INTO  app_user (id, username, email, password, password_request_token, roles, firstname, lastname, preferences, created, updated, last_login) VALUES ('eef57c38-56a6-43a7-8906-56c5b5b49452', 'user1', 'user1@test.us.com', '$2y$13$tvA.R0J.5pZXlB6K1dHQOetxSn42ID9ziB3FyftcuRBW3WgjCI/P2', null, 'a:1:{i:0;s:9:"ROLE_USER";}', '1', 'User', null, '2023-03-07 05:57:44', '2023-03-07 05:57:44', null);
INSERT INTO  app_user (id, username, email, password, password_request_token, roles, firstname, lastname, preferences, created, updated, last_login) VALUES ('d9360ea2-d07d-4aaf-8db0-307a117df032', 'user2', 'user2@test.us.com', '$2y$13$sXZU3Diu4s3Ns/N5Ov50Guw9y9im7j22MH5iKtqgm//dQ63lTnpO6', null, 'a:1:{i:0;s:9:"ROLE_USER";}', '2', 'User', null, '2023-03-07 05:57:44', '2023-03-07 05:57:44', null);
INSERT INTO  app_user (id, username, email, password, password_request_token, roles, firstname, lastname, preferences, created, updated, last_login) VALUES ('054d1988-3157-4ce8-b0af-6baec30313f1', 'user3', 'user3@test.us.com', '$2y$13$VfS89eOKCin/ia3K.BGvVekoA0xkeQpUP6ZiJHCxKtLVWb8Ua9V5W', null, 'a:1:{i:0;s:9:"ROLE_USER";}', '3', 'User', null, '2023-03-07 05:57:45', '2023-03-07 05:57:45', null);
INSERT INTO  app_user (id, username, email, password, password_request_token, roles, firstname, lastname, preferences, created, updated, last_login) VALUES ('84f7c0a7-2744-40a1-901a-dfdce9b415b3', 'user4', 'user4@test.us.com', '$2y$13$DT2uwTz4blO/dB1ElOg0ZOxW64SZfcO2ZjGqHHaBFztN5q/1yTua.', null, 'a:1:{i:0;s:9:"ROLE_USER";}', '4', 'User', null, '2023-03-07 05:57:46', '2023-03-07 05:57:46', null);
INSERT INTO  app_user (id, username, email, password, password_request_token, roles, firstname, lastname, preferences, created, updated, last_login) VALUES ('42afa890-3d54-46e0-8df0-c33500825b3e', 'user5', 'user5@test.us.com', '$2y$13$XZwNlZcPPrVEdEcMV/pV8urS.ovT3esu8xoF7K.tSL7u9vBfU2SS.', null, 'a:1:{i:0;s:9:"ROLE_USER";}', '5', 'User', null, '2023-03-07 05:57:46', '2023-03-07 05:57:46', null);
INSERT INTO  brand (id, name) VALUES ('9d27c731-7bee-4bb5-97ce-888c1b52b37b', 'Ferrero');
INSERT INTO  brand (id, name) VALUES ('a6fff595-136d-4948-85d2-32db6a430f34', 'Lete');
INSERT INTO  brand (id, name) VALUES ('13a33ef6-3a33-41e3-b219-48855761f7a0', 'Barilla, Mulino Bianco');
INSERT INTO  pantry (id, name, enabled) VALUES ('bc5d8e88-7354-4ffa-b8b9-f9f274ffd300', 'Armadio bianco', true);
INSERT INTO  pantry (id, name, enabled) VALUES ('bc5d8e88-7354-4ffa-b8b9-f9f274ffd301', 'Armadio rosso', true);

INSERT INTO  product (id, brand_id, name, barcode, openfoodfacts_url) VALUES ('2ea08ff1-4db2-442b-8387-45dcc728217e', '9d27c731-7bee-4bb5-97ce-888c1b52b37b', 'Nutella (400 g)', '3017620422003', null);
INSERT INTO  product (id, brand_id, name, barcode, openfoodfacts_url) VALUES ('744a242a-ec02-4001-b919-7a0190f821d0', 'a6fff595-136d-4948-85d2-32db6a430f34', 'Acqua Lete (1,5 l.)', '80412021', null);
INSERT INTO  product (id, brand_id, name, barcode, openfoodfacts_url) VALUES ('969dea40-4524-4f5a-904c-161c9113e6e9', 'a6fff595-136d-4948-85d2-32db6a430f34', 'Lete Acqua Effervescente NATUR. (50 cl)', '80412014', null);
INSERT INTO  product (id, brand_id, name, barcode, openfoodfacts_url) VALUES ('f3b5c5ba-359d-4ff8-98d4-f34223e4b8a5', '13a33ef6-3a33-41e3-b219-48855761f7a0', 'Pan carrè mulino bianco', '8076809569460', null);
INSERT INTO  product_presence (id, product_id, pantry_id, quantity, expiration) VALUES ('2ea08ff1-4db2-442b-8387-45dcc728217e', '2ea08ff1-4db2-442b-8387-45dcc728217e', 'bc5d8e88-7354-4ffa-b8b9-f9f274ffd300', 1, '2023-01-12');
INSERT INTO  product_presence (id, product_id, pantry_id, quantity, expiration) VALUES ('744a242a-ec02-4001-b919-7a0190f821d0', '744a242a-ec02-4001-b919-7a0190f821d0', 'bc5d8e88-7354-4ffa-b8b9-f9f274ffd300', 2, '2023-01-12');
INSERT INTO  product_presence (id, product_id, pantry_id, quantity, expiration) VALUES ('d4be9891-861b-4100-bc06-8ad87fec4899', '969dea40-4524-4f5a-904c-161c9113e6e9', 'bc5d8e88-7354-4ffa-b8b9-f9f274ffd300', 4, '2026-10-10');
INSERT INTO  users_pantries (pantry_id, user_id) VALUES ('bc5d8e88-7354-4ffa-b8b9-f9f274ffd300', 'eef57c38-56a6-43a7-8906-56c5b5b49452');
INSERT INTO  users_pantries (pantry_id, user_id) VALUES ('bc5d8e88-7354-4ffa-b8b9-f9f274ffd301', 'eef57c38-56a6-43a7-8906-56c5b5b49452');
